'-----------------------------------------------------------------
' CCTools IC-Bus-Routinen fr C-Control I V2.0
' zum PCF-UHR-WD & PCF-RTC-EEProm
' CCTools 2006 (http://cctools.hs-control.de)
'-----------------------------------------------------------------
' Die hufigsten IC-Bus-Adressen:
' &h20 - &h2E    MAX7311 16Bit Portexpander
' &h30 - &h3E    MAX7311 16Bit Portexpander
' &h40 - &h4E    MAX7311 16Bit Portexpander
' &h40 - &h4E    PCF8574 Portexpander
' &h50 - &h5E    MAX7311 16Bit Portexpander
' &h50 - &h5E    MAX520 4ch. 8Bit DA-Wandler
' &h68 - &h6E    MAX4572 Analog-Schalter (write only)
' &h70 - &h7E    PCF8574A Portexpander
' &h90 - &h9E    PCF8591 4ch. 8Bit AD-Wandler
' &h90 - &h9E    DS1631 12Bit Temperatursensor
' &hA0 - &hA2    PCF8583 Uhrenbaustein
' &hA0 - &hA6    serielle EEProms 24C128 - 24C512
' &hA0 - &hAE    serielle EEProms 24C01 - 24C64
' &hA0 - &hAE    MAX7311 16Bit Portexpander
' &hB0 - &hBE    MAX7311 16Bit Portexpander
' &hC0 - &hCE    MAX7311 16Bit Portexpander
' &hD0 - &hDE    MAX7311 16Bit Portexpander
'-----------------------------------------------------------------
' Programmgre 2465Byte (ca. 500 Byte mehr als vergleichbares Programm mit der C-Control I V1.1)
'-----------------------------------------------------------------


define SCL PORT[10]  ' Pull-Up mit je 10k empfohlen,
define SDA PORT[9] ' wenn die Busleitungen etwas lnger gezogen werden (>1m)


define wert Byte[1]
define data word[2]
define datalo byte[3]
define datahi byte[4]

define WDtimeout 20 ' Watchdogtimeout in Sekunden
define PCF8583addr 162 ' Adresse des PCF8583
define RAMyearAddr &h10 ' Speicheradresse fr Jahreszahl
define PCF8583Delay &h15' Verzgerung in Huntertstel, BCD-Kodiert

pause 1

'Programmbeginn

#initRTC

' Abfrage Statusregister
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 0
 print "#STOP#";
 print "#START#";
 put PCF8583addr OR 1
 get wert
 print "#STOP#";
 print "#OFF#";
 'wert=Statusregister. Wert=5 : Reset durch Watchdog
 print " Status:",wert
 pause 25

 'Die Aktivierung und das regelmige Zurcksetzen
 'des Watchdogs betrifft nur die Schaltung PCF-Uhr-WD (#1083),
 'nicht aber PCF-RTC-EEProm (#1084). Die WD-Zeilen
 'knnen dann auskommentiert werden.
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 0 ' Control/Statusregister
 put 4 ' Watchdog aktivieren
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 8 ' Alarm-Register
 put &h4A ' Watchdog aktivieren
 print "#STOP#";
 print "#OFF#";


 gosub resetWD 'Watchdogtimer zurcksetzen

 gosub syncCC1 'CC1-Uhr mit PCF8583-Zeit syncronisieren



#loop
 put 12
 gosub printdate : print
 gosub printtime : print
 print "Men: Leertaste drcken ...";
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 2
 print "#STOP#";
 print "#START#";
 put PCF8583addr or 1
 get datalo
 get datahi
 print "#STOP#";
 print "#OFF#";
 print datalo,datahi

 data=timer
 #timerloop
  if rxd then goto menu
 if timer-49<data then goto timerloop
 gosub resetWD
goto loop

#menu
 gosub syncPCF8583 'CC1-Uhr mit PCF8583 syncronisieren
 put 12
 print "1 - Uhrzeit stellen"
 print "2 - Datum stellen"
 print "3 - Absturz simulieren"
 print "4 - Watchdog deaktivieren & Programm beenden"
 print "0 - Men verlassen"
 gosub getvalue
 wert=wert-&h30
 on wert goto endmenu,settime,setdate,absturz,ende
goto menu

#endmenu
goto loop

#settime
 put 12
 print "Uhrzeit stellen:"
 gosub printtime
 put 13
 #enterhourhi
 gosub getvalue
 if (wert-&h30)>2 then goto enterhourHi
 put wert
 datalo=(wert-&h30)*10
 if datalo=2 then datahi=3 else datahi=9
 #enterhourlo
 gosub getvalue
 if (wert-&h30)>datahi then goto enterhourLo
 put wert
 datalo=datalo + (wert-&h30)
 hour=datalo
 put &h3A

 #enterminutehi
 gosub getvalue
 if (wert-&h30)>5 then goto enterMinuteHi
 put wert
 datalo=(wert-&h30)*10
 #enterminutelo
 gosub getvalue
 if (wert-&h30)>9 then goto enterMinuteLo
 put wert
 datalo=datalo + (wert-&h30)
 minute=datalo

 put &h3A
 #entersecondhi
 gosub getvalue
 if (wert-&h30)>5 then goto enterSecondHi
 put wert
 datalo=(wert-&h30)*10
 #entersecondlo
 gosub getvalue
 if (wert-&h30)>9 then goto enterSecondLo
 put wert
 datalo=datalo + (wert-&h30)
 second=datalo

 print
 print "Uhrzeit bernehmen (1) / Neueingabe(0)"
 gosub getvalue
 wert=wert-&h30
 if wert=1 then goto menu
goto settime

#setdate
 put 12
 print "Datum stellen:"
 gosub printdate
 put 13
 #enterdayhi
 gosub getvalue
 if (wert-&h30)>3 then goto enterDayHi
 put wert
 datalo=(wert-&h30)*10
 if datalo=3 then datahi=1 else datahi=9
 #enterdaylo
 gosub getvalue
 if (wert-&h30)>datahi then goto enterDayLo
 put wert
 datalo=datalo + (wert-&h30)
 day=datalo
 put &h2E

 #entermonthhi
 gosub getvalue
 if (wert-&h30)>5 then goto enterMonthHi
 put wert
 datalo=(wert-&h30)*10
 if datalo=1 then datahi=2 else datahi=9
 #entermonthlo
 gosub getvalue
 if (wert-&h30)>datahi then goto enterMonthLo
 put wert
 datalo=datalo + (wert-&h30)
 month=datalo

 put &h2E
 #enteryearhi
 gosub getvalue
 if (wert-&h30)>5 then goto enterYearHi
 put wert
 datalo=(wert-&h30)*10
 #enteryearlo
 gosub getvalue
 if (wert-&h30)>9 then goto enterYearLo
 put wert
 datalo=datalo + (wert-&h30)
 year=datalo

 put 9
 print "DOW: ";
 #enterDOW
 gosub getvalue
 if (wert-&h30)>6 then goto enterDOW
 put wert
 dow=wert-&h30

 print
 print "Datum bernehmen (1) / Neueingabe(0)"
 gosub getvalue
 wert=wert-&h30
 if wert=1 then goto menu
goto setdate

#absturz
 print "Simuliere Absturz ..."
 print "Warte auf Reset durch Watchdog ..."
 #aloop
 goto aloop
end

#ende
 gosub deactWD
 print "Watchdog abgeschaltet und Programm beendet"
end


#getvalue
 gosub waitrxd
 get wert
return

#waitrxd
 if rxd then return
 if (second mod 5)=0 then gosub resetWD
goto waitrxd

#printtime
 put hour/10 +&h30
 put hour mod 10 +&h30
 put &h3A
 put minute/10 +&h30
 put minute mod 10 +&h30
 put &h3A
 put second/10 +&h30
 put second mod 10 +&h30
return

#printdate
 put day/10 +&h30
 put day mod 10 +&h30
 put &h2E
 put month/10 +&h30
 put month mod 10 +&h30
 put &h2E
 put year/10 +&h30
 put year mod 10 +&h30
 put 9
 print "DOW: ";dow;
return


'-------------------------------------------------------------------------------
#syncCC1
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 2
 print "#STOP#";
 print "#START#";
 put PCF8583addr or 1
 get wert
 #secloop
  print "#STOP#";
  print "#START#";
  put PCF8583addr
  put 2
  print "#STOP#";
  print "#START#";
  put PCF8583addr or 1
  get datalo
 if datalo=wert then goto secloop 'Sekundenwechsel abwarten
 second=(datalo shr 4)*10 + (datalo and &hF)
 get datahi
 minute=(datahi shr 4)*10 + (datahi and &hF)
 get wert
 hour=(wert shr 4)*10 + (wert and &hF)
 get datalo
 day=((datalo shr 4) and &b11)*10 + (datalo and &hF)
 get datahi
 month=((datahi shr 4) and &b1)*10 + (datahi and &hF)
 dow=datahi shr 5
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put RAMyearAddr
 print "#STOP#";
 print "#START#";
 put PCF8583addr or 1
 get wert
 print "#STOP#";
 datahi=(wert and &b11111100) or (datalo shr 6)
 if (wert and &b11) = (datahi and &b11) then goto noyearchanged
  wert=wert+1
  print "#START#";
  put PCF8583addr
  put RAMyearAddr
  put wert
  print "#STOP#";
 #noyearchanged
 print "#OFF#";
 year=wert
return


#syncPCF8583
 wert=second
 #waitsecchange
 if wert=second then goto waitsecchange
 wert=second

 datalo=PCF8583Delay
 datahi=((second / 10) shl 4) or (second mod 10)
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 1
 put datalo 
 put datahi
 
 datalo=((minute / 10) shl 4) or (minute mod 10)
 datahi=((hour / 10) shl 4) or (hour mod 10)
 put datalo 
 put datahi

 datalo=(((day / 10) and &b11) shl 4) or (day mod 10)
 datalo=datalo or ((year mod 4) shl 6)
 datahi=(((month / 10) and 1) shl 4) or (month mod 10)
 datahi=datahi or ((DOW mod 7) shl 5)
 put datalo 
 put datahi

 print "#STOP#";

 wert=year
 print "#START#";
 put PCF8583addr
 put RAMyearAddr
 put wert
 print "#STOP#";

 print "#OFF#";
return

#resetWD 'Watchdog zurcksetzen
 wert=99-WDtimeout
 wert=((wert/10) shl 4) or (wert mod 10)
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 7 
 put wert 
 print "#STOP#";
 print "#OFF#";
return

#deactWD 'Watchdog abschalten
 print "#ON_IIC#";
 print "#STOP#";
 print "#START#";
 put PCF8583addr
 put 8
 put 0 
 print "#STOP#";
 print "#OFF#";
return





